# Crtanje rozeta sastavljenih od kružnih isječaka: primjer_08_19 

from turtle import *
import random

title('Obojena rozeta sastavljena od bojanih kružnih isječaka')

def kruž_isječak(x_s, y_s, r, kut_p, kut_i):
    '''Funkcija crta kružni isječak kružnice
    x_s,y_s  - koordinate središta 
    r - polumjer kružnice
    kut_p - kut zakreta isječka u stupnjevima (kut_p mjeri se od osi x
            obrnuto od smjera kazaljke na satu, tip int ili float)
    kut_i - središnji kut kružnog isječka (tip int ili float)'''        
    ht(); pensize(1); seth(0)
    pu(); goto(x_s, y_s); pd()
    lt(kut_p); fd(r)
    lt(90); circle(r, kut_i)
    lt(90); fd(r)
    return

def obojena_rozeta(x_s, y_s, r, br_listova):
    kut_i = 180 / br_listova						# 1
    colormode(255)							# 2
    tracer(False)							# 3
    for i in range(br_listova):
        R = random.randint(1, 255)
        G = random.randint(1, 255)
        B = random.randint(1, 255)
        color (R, G, B)							# 4
        begin_fill()
        kut_p = 2 * i * kut_i
        kruž_isječak(x_s, y_s, r, kut_p, kut_i)
        end_fill()
    tracer(True)							# 5
    return

def main():
    ponavljanje = True
    while ponavljanje:
        sr_kru = textinput('Središte kružnice', 'Upisati koordinate x, y').split(',')
        x_s = int(sr_kru[0]); y_s = int(sr_kru[1])
        r = int(textinput('Polumjer', 'Upisati duljinu polumjera'))
        n = int(textinput('Broj listova', 'Upisati broj'))
        obojena_rozeta(x_s, y_s, r, n)
        pon = textinput('Ponoviti crtanje?', 'Za ponavljanje upisati: da')
        if pon == 'da':
            reset(); ht()
        else:
            ponavljanje = False    
    return

main()
pu()
goto(0, -280)
pencolor('black')
write('Klikom miša na gumb X okončati program', align = 'center')
mainloop()
